Junkee = Junkee or {}
Junkee.__index = Junkee
Junkee.name = "Junkee"
Junkee.hooks = {}

Junkee.bagId 	= 0
Junkee.slotId	= 0
Junkee.isJunk   = false


Junkee.OnMouseEnter = function(control)
	Junkee.bagId 	= control.dataEntry.data.bagId
	Junkee.slotId 	= control.dataEntry.data.slotIndex
	Junkee.isJunk	= control.dataEntry.data.isJunk

	Junkee.AddJunkAction()
end


Junkee.OnMouseExit = function(control)
	Junkee.RemoveJunkAction()
end


Junkee.Loaded = function(eventCode, addonName)
	if (Junkee.name == addonName) then
		local row, i, control
		i = 1
		repeat
			row = "ZO_PlayerInventoryBackpack1Row" .. i
			control = _G[row]
			if control ~= nil then
				ZO_PreHookHandler(control, "OnMouseEnter", Junkee.OnMouseEnter)
				ZO_PreHookHandler(control, "OnMouseExit",  Junkee.OnMouseExit)
				i = i + 1
			end
		until control == nil
	end
end


Junkee.JunkIt = function()
	local isJunk = IsItemJunk(Junkee.bagId, Junkee.slotId)
	SetItemIsJunk(Junkee.bagId, Junkee.slotId, not isJunk)
	if isJunk then	
		PlaySound(SOUNDS.INVENTORY_ITEM_UNJUNKED)		
	else
		PlaySound(SOUNDS.INVENTORY_ITEM_JUNKED)		
	end
end


Junkee.DeleteIt = function()
	DestroyItem(Junkee.bagId, Junkee.slotId)
end


local function createJunkStripDescriptor(name)
	return JunkeeKeyStrip:New(name, "JUNKEE_JUNK_IT", Junkee.JunkIt)
end


local junkStripDescriptor = createJunkStripDescriptor(Junkee.tr("JunkLabel"))
local unjunkStripDescriptor = createJunkStripDescriptor(Junkee.tr("UnjunkLabel"))
local deleteStripDescriptor = JunkeeKeyStrip:New(Junkee.tr("DeleteLabel"), "JUNKEE_DELETE_IT", Junkee.DeleteIt)


Junkee.AddJunkAction = function()
	if (Junkee.isJunk == true) then
		unjunkStripDescriptor:Add(true)
	else
		junkStripDescriptor:Add(true)
	end
end


Junkee.RemoveJunkAction = function()
	junkStripDescriptor:Remove()
	unjunkStripDescriptor:Remove()
	deleteStripDescriptor:Remove()
end


EVENT_MANAGER:RegisterForEvent("Junkee", EVENT_ADD_ON_LOADED, Junkee.Loaded)
ZO_CreateStringId("SI_BINDING_NAME_JUNKEE_JUNK_IT", Junkee.tr("JunkBindingName"))
ZO_CreateStringId("SI_BINDING_NAME_JUNKEE_DELETE_IT", Junkee.tr("DeleteBindingName"))
